const url = require('url');
const SockJS = require('sockjs-client');

let connection = new SockJS(url.format({
  protocol: window.location.protocol,
  hostname: window.location.hostname,
  port: window.location.port,
  pathname: '/sockjs-node',
}));

connection.onclose = function() {
  console.info('The development server has disconnected!')
}

let isFirstCompile = true;
let nowHashs;
function hanldeSuccess() {
  let hotUpdate = !isFirstCompile;
  isFirstCompile = false;

  if(hotUpdate) {
    // no hot repalce hot module
    if(!module.hot) {
      window.location.reload();
      return;
    }

    function handleApplyUpdates(err, updateModule) {
      if(err || !updateModule) {
        window.location.reload();
        return;
      }

      if(isHashsChange()) {
        hanldeSuccess();
      }
    }

    module.hot.check(/* autoApply */ true, handleApplyUpdates);
  }
  
}

function isHashsChange() {
  return __wepack_hash__ !== nowHashs;
}

function hanldeHashs(hash) {
  nowHashs = hash;
}

function handleWarnings() {

}

function handleErrors() {

}
  
connection.onmessage = function(stat) {
  const data = JSON.parse(stat.data);
  // console.log(data);
  switch(data.type) {
    case 'hash':
      hanldeHashs(data.data);
      break;
    case 'still-ok':
    case 'ok':
      hanldeSuccess();
      break;
    case 'content-changed':
      window.location.reload();
      break;
    case 'warnings':
      handleWarnings();
      break;
    case 'errors':
      handleErrors();
      break;
    default:
      // do nothing
  }
}